﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using System.Windows.Media.Imaging;
using System.IO;

namespace _341147_UploadExample
{
	public partial class MainPage : UserControl
	{
		public MainPage()
		{
			InitializeComponent();
		}

		private void myUpload_FileUploadStarting(object sender, FileUploadStartingEventArgs e)
		{
			RadUploadSelectedFile file = e.SelectedFile as RadUploadSelectedFile;
			WriteableBitmap wb;

			using (Stream stream = file.File.OpenRead())
			{
				wb = ResizeImage(stream, 300); //resize the image to 300 pix
			}

			byte[] buffer;
			using (Stream Source = JpgEncoder.Encode(wb, 80))
			{
				int bufferSize = Convert.ToInt32(Source.Length);
				buffer = new byte[bufferSize];
				Source.Read(buffer, 0, bufferSize);				
			}

			//NOTE: use the buffer to show the image...

			e.NewFileStream = new MemoryStream(buffer);
		}

		private WriteableBitmap ResizeImage(Stream stream, double targetSize)
		{
			BitmapImage bmp = new BitmapImage();


			bmp.SetSource(stream);

			System.Windows.Controls.Image img = new System.Windows.Controls.Image();
			img.Source = bmp;
			double scaleX = 1;
			double scaleY = 1;

			if (bmp.PixelHeight > targetSize)
				scaleY = targetSize / bmp.PixelHeight;
			if (bmp.PixelWidth > targetSize)
				scaleX = targetSize / bmp.PixelWidth;


			double scale = Math.Min(scaleY, scaleX);

			int newWidth = Convert.ToInt32(bmp.PixelWidth * scale);
			int newHeight = Convert.ToInt32(bmp.PixelHeight * scale);
			WriteableBitmap result = new WriteableBitmap(newWidth, newHeight);
			result.Render(img, new ScaleTransform() { ScaleX = scale, ScaleY = scale });
			result.Invalidate();
			return result;
		}

	}
}
